import numpy as np
import pandas as pd

import matplotlib.pyplot as plt
import seaborn as sns

import statsmodels.api as sm
from scipy import stats

import metro as mt

def main():
    do_13016()


def do_13016():

    from Table13016 import Table13016

    # Seaborn 
    sns.set_palette("deep", desat=.6)
    sns.set_context(rc={"figure.figsize": (8, 4)})

    for city in cities:

        mogo = mt.MetroMogo()
        df = mogo.get_df(city,tablecode="B13016")

        df = Table13016(df)

        #######################
        # KDE plot:
        #
        # avg birth rate
        # var birth rate

        f, ax1 = plt.subplots(1, 1, sharex=False, figsize=(6, 6))
        ax1.set_title(cities[0])

        colors = ["windows blue", 
                  "dusty purple", 
                  "faded green", 
                  "amber"]
        xcp = sns.xkcd_palette(colors)

        # ------------
        # Subplot 1

        xcode = 'BirthRateAvg'
        xlabel=xcode
        sns.kdeplot(df[xcode], shade=True, color=xcp[2], ax=ax1)
        ax1.set_xlim([0,0.30])

        # ------------
        # Subplot 2

        xcode = 'BirthRateVariance'
        xlabel=xcode
        sns.kdeplot(df[xcode], shade=True, color=xcp[1], ax=ax1)
        ax1.set_xlim([0,1.0])

        ax1.set_xlabel("Avg/Variance")
        ax1.set_ylabel("Probability Density")

        plt.show()


if __name__=="__main__":
    main()


