import numpy as np
import pandas as pd

import matplotlib.pyplot as plt
import seaborn as sns

import statsmodels.api as sm
from scipy import stats

import metro as mt

def main():
    do_25013()

def do_25013():

    from Table25013 import Table25013

    # Seaborn 
    sns.set_palette("deep", desat=.6)
    sns.set_context(rc={"figure.figsize": (8, 4)})

    for city in cities:

        mogo = mt.MetroMogo()
        df = mogo.get_df(city,tablecode="B25013")

        df = Table25013(df)



        #######################
        # 
        # renters vs owners
    
        f, ax1 = plt.subplots(1, 1, sharex=True, figsize=(12, 6))

        cmap = sns.cubehelix_palette(8, start=0.5, rot=-.75, as_cmap=True)

        # ------------------------
        # Subplot 1
    
        ax1.set_title(cities[0])

        sns.kdeplot(df['HousePct'],df['RentPct'],shade=True,cmap=cmap,ax=ax1)
        ax1.set_xlim([0,1])
        ax1.set_ylim([0,1])

        ax1.set_xlabel('Pct Homeowners')
        ax1.set_ylabel('Pct Renters')




        #######################
        # Rent-Own plots
        # for each education category

        f, ((ax1,ax2),(ax3,ax4)) = plt.subplots(2, 2, sharex=False, figsize=(12, 10))

        cmap = sns.cubehelix_palette(8, start=.8, rot=-.55, as_cmap=True)
        
        axes = [ax1,ax2,ax3,ax4]
        for i in range(4):
            ip1 = i+1

            sns.kdeplot(df['EdCat%d_HousePct'%(ip1)],df['EdCat%d_RentPct'%(ip1)],shade=True,cmap=cmap,ax=axes[i])
            axes[i].set_xlim([0,1])
            axes[i].set_ylim([0,1])
            axes[i].set_title("Cat%d"%(ip1))

        axes[3].set_xlabel('Pct Homeowners')
        axes[0].set_ylabel('Pct Renters')
        axes[1].set_ylabel('Pct Renters')
        axes[2].set_ylabel('Pct Renters')
        axes[3].set_ylabel('Pct Renters')

        plt.show()


cities = ['Seattle']

if __name__=="__main__":
    main()

