import numpy as np
import pandas as pd

import matplotlib.pyplot as plt
import seaborn as sns

import statsmodels.api as sm
from scipy import stats

import metro as mt

def main():
    do_25105()

def do_25105():

    from Table25105 import Table25105

    # Seaborn 
    sns.set_palette("deep", desat=.6)
    sns.set_context(rc={"figure.figsize": (8, 4)})
    
    for city in cities:

        mogo = mt.MetroMogo()
        df = mogo.get_df(city,tablecode="B25070")

        df = Table25105(df)


        #######################
        # KDE plot:
        #
        # per capita income

        f, ax1 = plt.subplots(1, 1, sharex=True, figsize=(8, 8))
        ax1.set_title(cities[0])

        colors = ["windows blue", "amber", "greyish", "faded green", "dusty purple"]
        xcp = sns.xkcd_palette(colors)

        # -------------
        # subplot 1

        xcode = 'MedianMonthlyHousingCosts'
        xlabel=xcode

        sns.kdeplot(df[xcode], shade=True, color=xcp[3], ax=ax1)

        plt.show()


cities = ['Seattle']

if __name__=="__main__":
    main()



