import numpy as np
import pandas as pd

import matplotlib.pyplot as plt
import seaborn as sns

import statsmodels.api as sm
from scipy import stats

import metro as mt

def main():
    do_13016()

def get_colors():

    p1 = ["windows blue",
          "dusty purple",
          "faded green",
          "amber"]

    p2 = ["blue green",
          "dark salmon",
          "hospital green",
          "blurple"]

    xcps = [sns.xkcd_palette(p1),
            sns.xkcd_palette(p2)]

    return xcps


def do_13016():

    from Table13016 import Table13016

    # Seaborn 
    sns.set_palette("deep", desat=.6)
    sns.set_context(rc={"figure.figsize": (8, 4)})



    #######################
    # KDE plot:
    #
    # avg birth rate
    # var birth rate

    brate_f, brate_ax1 = plt.subplots(1, 1, sharex=False, figsize=(6, 6))



    for ic,city in enumerate(cities):

        xcp = xcps[ic]

        mogo = mt.MetroMogo()
        df = mogo.get_df(city,tablecode="B13016")
        df = Table13016(df)

        brate_ax1.set_title(city)

        # ------------
        # Subplot 1

        xcode = 'BirthRateAvg'
        xlabel=xcode

        sns.kdeplot(df[xcode], shade=True, color=xcp[0], ax=brate_ax1, label=xcode+" "+city)
        brate_ax1.set_xlim([0,0.30])

        # ------------
        # Subplot 2

        xcode = 'BirthRateVariance'
        xlabel=xcode

        sns.kdeplot(df[xcode], shade=True, color=xcp[1], ax=brate_ax1, label=xcode+" "+city)
        brate_ax1.set_xlim([0,1.0])

        brate_ax1.set_xlabel("Avg/Variance")
        brate_ax1.set_ylabel("Probability Density")


    plt.show()

xcps = get_colors()

cities = ['Seattle','San Francisco']

if __name__=="__main__":
    main()



