import numpy as np
import pandas as pd


def Cube17001(row):
    """
    Pass in a row from a DataFrame
    Receive a three-dimensional numpy array (a cube)
    """
    table_fields = np.array([[['B17001004', 'B17001018'],       # under 5
                              ['B17001005', 'B17001019'],       # 5
                              ['B17001006', 'B17001020'],       # 6-11
                              ['B17001007', 'B17001021'],       # 12-14
                              ['B17001008', 'B17001022'],       # 15
                              ['B17001009', 'B17001023'],       # 16-17
                              ['B17001010', 'B17001024'],       # 18-24
                              ['B17001011', 'B17001025'],       # 25-34
                              ['B17001012', 'B17001026'],       # 35-44
                              ['B17001013', 'B17001027'],       # 45-54
                              ['B17001014', 'B17001028'],       # 55-64
                              ['B17001015', 'B17001029'],       # 65-74
                              ['B17001016', 'B17001030']],      # 75
                      
                             [[ 'B17001033', 'B17001047'],
                              [ 'B17001034', 'B17001048'],
                              [ 'B17001035', 'B17001049'],
                              [ 'B17001036', 'B17001050'],
                              [ 'B17001037', 'B17001051'],
                              [ 'B17001038', 'B17001052'],
                              [ 'B17001039', 'B17001053'],
                              [ 'B17001040', 'B17001054'],
                              [ 'B17001041', 'B17001055'],
                              [ 'B17001042', 'B17001056'],
                              [ 'B17001043', 'B17001057'],
                              [ 'B17001044', 'B17001058'],
                              [ 'B17001045', 'B17001059']]])

    dims = table_fields.shape
    cube = np.zeros(list(dims))

    # quick b/c small. 
    # this is more for playing with, 
    # than heavy duty computations.
    # remember we're still just visualizing.

    for i in range(dims[0]):
        for j in range(dims[1]):
            for k in range(dims[2]):
                key = table_fields[i,j,k]
                cube[i,j,k] = row[key]

    # eventually we can iterate through 
    # slices of the array above 
    # to iterate through columns of a whole dataframe
    # and implement formulas that way.

    return cube

