import json
import csv
import pkg_resources 

def FIPSCode(state):
    """
    Return the FIPS code of the requested state.
    state variable can be either two-letter abbrev
    or full name.
    """
    with open('geocodes/fips.json','r') as f:
        d = json.load(f)
    return d[state]

def CBSACode(term):
    """
    Search for the CBSA code for 
    any city matching 'term'.
    Return a list with all matching results.
    """
    with open('geocodes/cbsa.csv','r') as f:
        reader = csv.reader(f)
        cbsa = [(rows[0],rows[1]) for rows in reader]

    codes = []
    for (cbsa_code,name) in cbsa:
        # sloppy search: just return the first match
        if term in name:
            codes.append(cbsa_code)
    return codes


