from Codes import *
from timeit import default_timer as timer
import json
import urllib2
import numpy as np
import re
import os
import subprocess

cities = ['Seattle','Houston','Dallas','Chicago','New York','Los Angeles','San Francisco']

metroCodes = {}
for city in cities:
    metroCodes[city] = CBSACode(city)[0]


def get_geotables(target_geoid):

    geo_api_url   = "http://api.censusreporter.org/1.0/geo/show/tiger2013?geo_ids=GEOID"

    api_call = re.sub('GEOID',target_geoid,geo_api_url)
    tables = json.load(urllib2.urlopen(api_call))
    return tables




county_level = "050"
censustract_level = "140" 
metro_level = "310"
congressional_level = "500"
zipcode_level = "860"

for metro_name in metroCodes.keys():

    metro_id = metroCodes[metro_name]

    # summary:
    # return information about the whole metro area
    metro_geoid = metro_level + "00" + "US" + metro_id
    metro_tables = get_geotables(metro_geoid)

    # parent/child:
    # return information about each county in the metro area
    # for each county:
    #   return information about each census tract in the county

    # counties in metro area:
    county_geoids = county_level + "|" + metro_level + "00" + "US" + metro_id
    county_tables = get_geotables(county_geoids)
    for county_table in county_tables['features']:

        county_id    = county_table['properties']['geoid'][7:]
        county_geoid = county_table['properties']['geoid']

        # for census tracts in county:
        census_geoids = censustract_level + "|" + county_level + "00US" + county_id
        census_tables = get_geotables(census_geoids)

        for census_table in census_tables['features']:

            censustract_id    = census_table['properties']['geoid'][7:]
            censustract_geoid = census_table['properties']['geoid']

            print censustract_id + " <-- " + county_id + " <-- " + metro_id



'''
http://api.censusreporter.org/1.0/geo/show/tiger2013?geo_ids=050|31000US41860
                                                             ^^^
                                                             050 return county level information

                                                                 ^^^
                                                                 310 use metro geoid that will be passed
                                                                     ^^ ^^ 
                                                                     00 US
                                                                         ^^^^^
                                                                         41860 your city metro ID (SF, in this case)
'''

